import Utils from '@/extend/Utils';
import HttpRequest from '@/extend/HttpRequest';
import {host, http} from '@/config';
import router from '@/router';

export default class Http {

    public static getInstance(...args: any[]): any {
        let Class: any = this;
        if (!Class._instance) {
            let argsLen: number = args.length;
            if (argsLen === 0) {
                Class._instance = new Class();
            } else {
                Class._instance = new Class(...args);
            }
        }
        return Class._instance;
    }

    public httpClient: HttpRequest = HttpRequest.getInstance();

    async login(params: any) {
        return this.httpClient.request({
            url: http.login,
            method: 'POST',
            data: params,
        });
    }

    async sns(params: any) {
        return this.httpClient.request({
            url: http.sns,
            data: params,
        });
    }

    async userinfo(params: any = null) {
        return this.httpClient.request({
            url: http.userinfo,
            method: 'POST',
            data: params,
        });
    }

    async saveBase(params: any = null) {
        return this.httpClient.request({
            url: http.baseinfo,
            method: 'POST',
            data: params,
        });
    }

    async socialLimit(params: any = null) {
        return this.httpClient.request({
            url: http.sociallimit,
            data: params,
        });
    }

    async calcBill(params: any = null) {
        return this.httpClient.request({
            url: http.calcbill,
            data: params,
        });
    }

    async saveOrder(params: any = null) {
        return this.httpClient.request({
            url: http.createorder,
            method: 'POST',
            data: params,
        });
    }

    async payOrder(params: any = null) {
        return this.httpClient.request({
            url: http.payorder,
            method: 'POST',
            data: params,
        });
    }

    async getConfig(params: any = null) {
        return this.httpClient.request({
            url: http.getconfig,
            method: 'GET',
            data: params,
        });
    }

    async getPayInfo(params: any = null) {
        return this.httpClient.request({
            url: http.getpayinfo,
            method: 'GET',
            data: params,
        });
    }

    async getOrderList(params: any = null) {
        return this.httpClient.request({
            url: http.getorderlist,
            method: 'GET',
            data: params,
        });
    }

    async getOrderDetail(params: any = null) {
        return this.httpClient.request({
            url: http.getorderdetail,
            method: 'GET',
            data: params,
        });
    }

    async getInvitationList(params: any = null) {
        return this.httpClient.request({
            url: http.getinvitationlist,
            method: 'GET',
            data: params,
        });
    }

    async getSocialConfig(params: any = null) {
        return this.httpClient.request({
            url: http.getsocialconfig,
            method: 'GET',
            data: params,
        });
    }

    async getVerifyCode(params: any = null) {
        return this.httpClient.request({
            url: http.getverifycode,
            method: 'GET',
            data: params,
        });
    }

    async getDiscountListt(params: any = null) {
        return this.httpClient.request({
            url: http.getyouhui,
            method: 'GET',
            data: params,
        });
    }

    async getWeixin(params: any = null) {
        return this.httpClient.request({
            url: http.getweixin,
            method: 'GET',
            data: params,
        });
    }

    async getAlipay(params: any = null) {
        return this.httpClient.request({
            url: http.getalipay,
            method: 'GET',
            data: params,
        });
    }

}
