import {Component, Vue} from 'vue-property-decorator';
import Http from '../../extend/Http';
import Utils from '../../extend/Utils';
import wx from 'weixin-jsapi';
import router from '@/router';

@Component({
    components: {}
})

export default class UserIndex extends Vue {

    public data: any = {
        hour: 0,
        minute: 0,
        second: 0,
        orderSn: '0',
        totalCharge: '0',
        payment: 'weixin',
        model: false,
        html:''
    };
    private closeTime: string = '0';
    private timer: number = 0;

    async created() {
        console.log(router);
    }

    mounted() {
        let info = JSON.parse(localStorage.getItem('order_paying') as string);
        this.closeTime = info.close_timestamp;
        this.data.totalCharge = info.total_charge;
        this.data.orderSn = info.order_sn;
        // this.countTime(this.closeTime);
    }

    async payment(platform: string) {
        // let res = await Http.getInstance().payOrder({
        //     order_sn: this.data.orderSn, platform: platform, remark: '订单支付'
        // });
        // let res = await Http.getInstance().getWeixin({
        //     order_sn: this.data.orderSn,
        //     platform: 'weixin',
        //     pay:'wappay'
        // });
        let res = await Http.getInstance().getWeixin({
            order_sn: this.data.orderSn,
            platform: 'weixin',
            pay:'wappay'
        });
        console.log(res)
        window.location.replace(res.data.mweb_url+'&redirect_url='+encodeURIComponent(window.location.href+'&tip=yes'))

        // console.log(this.data.orderSn)
        // this.data.model = true;
        // this.data.payment = platform;
        // switch (platform) {
        //     case 'weixin':
        //         // this.wxpay(res.data);
        //         this.data.payment = 'weixin';
        //         break;
        //     case 'alipay':
        //         // this.alipay(res.data);
        //         break;
        //     case 'union':
        //         // this.unionpay(res.data);
        //         break;
        // }
    }
    async alipayment(platform: string) {

        let res = await Http.getInstance().getAlipay({
            order_sn: this.data.orderSn,
            platform: 'alipay',
            pay:'wappay'
        });
        console.log(res.data)
        this.data.html = res.data
        let form= res.data;
        const div = document.createElement('div')
        div.innerHTML = form//此处form就是后台返回接收到的数据
        document.body.appendChild(div)
        document.forms[0].submit()
    }

    private countTime(datetime: any): any {
        this.timer = setInterval(() => {
            // 获取当前时间
            let now = new Date().getTime();
            // 设置截止时间
            let end = new Date(datetime).getTime();
            // 时间差
            let left = end - now;
            if (left > 0) {
                this.data.hour = Utils.getInstance().prefixInteger(Math.floor(left / 3600000));
                this.data.minute = Utils.getInstance().prefixInteger(Math.floor((left / 60000) % 60));
                this.data.second = Utils.getInstance().prefixInteger(Math.floor((left / 1000) % 60));
            } else {
                clearInterval(this.timer);
                router.replace({
                    name: 'olist',
                });
            }
        }, 1000);
    }

    private async wxpay(data: any) {
        let info = JSON.parse(localStorage.getItem('order_paying') || '');
        console.log('info');
        let res = await Http.getInstance().getConfig({
            platform: 'weixin', order_sn: info.order_sn, url: location.href.slice(0, -7)
        });
        res.data.jsApiList = ['chooseWXPay'];
        console.log(res);
        wx.config(res.data);
        wx.ready(() => {
            wx.chooseWXPay({
                timestamp: data.timeStamp, // 支付签名时间戳，注意微信jssdk中的所有使用timestamp字段均为小写。但最新版的支付后台生成签名使用的timeStamp字段名需大写其中的S字符
                nonceStr: data.nonceStr, // 支付签名随机串，不长于 32 位
                package: data.package, // 统一支付接口返回的prepay_id参数值，提交格式如：prepay_id=\*\*\*）
                signType: data.signType, // 签名方式，默认为'SHA1'，使用新版支付需传入'MD5'
                paySign: data.paySign, // 支付签名
                success: (res: any) => {
                    alert(res);
                    if (res) {
                        localStorage.removeItem('order_paying');
                        router.replace('orderList');
                    } else {
                    }
                }
            });
        });
        wx.error((err: any) => {
            alert(JSON.stringify(err));
        });
    }

    private alipay(data: any) {

    }

    private unionpay(data: any) {

    }
}
